/* main.c for file transfer */

#define compilingmain

#include "commonstuff.h"
#include <sys/ioctl.h>
#include <sys/time.h>


/* external function links for file transfer routines */
/* They apply to both sendfile and receivefile */
extern  void      DoIdle(void);
extern  void      ReceiveBytes(char* Data, long Length);
extern  void      InitModule(int argc, char* argv[]);


#define RATE (3L) /* 60ths of a second */

static jmp_buf             sjbuf;

volatile short             Idling = False;

volatile unsigned long     TickTrack;


void    DieProc(void)
  {
    APRINT(("+DieProc\n"));
    signal(SIGALRM,SIG_IGN);
    SetTTYInfo(0,&OriginalTTY);
    sleep(2);
    APRINT(("DieProc almost done\n"));
    exit(0);
    APRINT(("-DieProc\n"));
  }


void    IdleProc(void)
  {
    TickTrack += RATE; /* increment clock */
    signal(SIGALRM,(void*)&IdleProc); /* reset interrupt thingie */
    return; /* return to location of interrupt */
  }


void    main(int argc, char* argv[])
  {
    struct itimerval  Timer;
    struct itimerval  TimerOld;
    TTYInfo           NewTTY;

#ifdef dBUG
    bugfile = fopen("audit","w");
    fprintf(bugfile,"Debugging:\n");
    fflush(bugfile);
#endif

    APRINT(("+main\n"));

    GetTTYInfo(0,&OriginalTTY);
    NewTTY = OriginalTTY;
    MakeSpiffyTTY(&NewTTY);
    SetTTYInfo(0,&NewTTY);

    signal(SIGQUIT,(void*)&DieProc);
    signal(SIGINT,(void*)&DieProc);

    InitModule(argc - 1,argv + 1); /* pass in list of files (if any) */
    Timer.it_interval.tv_sec = 0;
    Timer.it_interval.tv_usec = RATE * 16666L;
    Timer.it_value.tv_sec = 0;
    Timer.it_value.tv_usec = 10000; /* start with .1 second to go */
    TimerOld = Timer;
    setitimer(ITIMER_REAL,&Timer,&TimerOld);
    setjmp(sjbuf);
    signal(SIGALRM,(void*)&IdleProc);
    while (!QuitFlag)
      {
        /* do idle task */
        DoIdle();
        /* wait for next interrupt */
        pause();
      }
    signal(SIGALRM,SIG_IGN);


    /* wait for quiescence on input port */
    {
      char    Buffer[256];
      int     Length;
      int     CycleCount;

      CycleCount = 0;
      while (CycleCount < 3)
        {
          Length = read(0,Buffer,256);
          if (Length > 0)
            {
              CycleCount = 0;
            }
          sleep(1);
          CycleCount += 1;
        }
      }
    SetTTYInfo(0,&OriginalTTY);

    APRINT(("-main\n"));
  }


/* stupid things since we use pty.c, to prevent undefined symbol errors */
void      TerminalWantsToDieCloseSession(CTerminal* OneThatDied)
  {
  }

MyBoolean       ReceiveDataFromLocalTerminal(char* Data, short Length, CTerminal* Sender)
  {
  }

int          Handlers[1];
int          Buffers[1];
